/**
 * Copyright (C) 2003-2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#include <stdio.h>

#include "debug.h"

void printFieldType(WORD type) {
    char typeName[16];

    switch (type) {
        case CEVT_BLOB:
            strcpy(typeName, "BLOB");
            break;
        case CEVT_BOOL:
            strcpy(typeName, "BOOL");
            break;
        case CEVT_FILETIME:
            strcpy(typeName, "FILETIME");
            break;
        case CEVT_I2:
            strcpy(typeName, "INT16");
            break;
        case CEVT_I4:
            strcpy(typeName, "INT32");
            break;
        case CEVT_LPWSTR:
            strcpy(typeName, "STRING");
            break;
        case CEVT_R8:
            strcpy(typeName, "INT64");
            break;
        case CEVT_UI2:
            strcpy(typeName, "UINT16");
            break;
        case CEVT_UI4:
            strcpy(typeName, "UINT32");
            break;
        default:
            strcpy(typeName, "Unknown");
            break;
    }

    printf("\ttype: %s (%d)\n", typeName, type);
}

void printFieldValue(CEVALUNION val, WORD type) {
    printf("\tvalue: ");
    switch (type) {
        case CEVT_BLOB:
            printf("...\n");
            break;
        case CEVT_BOOL:
            printf("%s\n", (val.boolVal == TRUE) ? "TRUE" : "FALSE");
            break;
        case CEVT_FILETIME:
            printf("...\n");
            break;
        case CEVT_I2:
            printf("%d\n", val.iVal);
            break;
        case CEVT_I4:
            printf("%d\n", val.lVal);
            break;
        case CEVT_LPWSTR:
            wprintf(TEXT("%s\n"), val.lpwstr);
            break;
        case CEVT_R8:
            printf("%f\n", val.dblVal);
            break;
        case CEVT_UI2:
            printf("%u\n", val.uiVal);
            break;
        case CEVT_UI4:
            printf("%u\n", val.ulVal);
            break;
        default:
            printf("%s\n", "...");
            break;
    }
}

void printField(CEPROPVAL *field) {
    WORD id   = HIWORD(field->propid);
    WORD type = LOWORD(field->propid);

    printf("\tid: %d\n", id);
    printFieldType(type);
    printFieldValue(field->val, type);
}